from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addParameter("boatwidth", 90, paramType="length")
c.addParameter("boatdepth", 70, paramType="length")

c.addParameter("numBatteries", 3, paramType="count", minValue=1, maxValue=10)

c.addSubcomponent("holder", "SimpleRectBeam", inherit=True, prefix=None)
c.addConstConstraint(("holder", "depth"), 60)
c.addConstraint(("holder", "length"), ("numBatteries"), "9 * x")
c.addConstConstraint(("holder", "width"), 17)

c.addSubcomponent("larm", "Rectangle", inherit=True)
c.addConstraint(("larm", "l"), ("numBatteries", "boatwidth", "boatdepth"), "((0.5 * x[1] - 0.5 * ( 9 * x[0])) ** 2 + (x[2] - 17) ** 2) ** 0.5")
c.addConstConstraint(("larm", "w"), 60)

c.addSubcomponent("rarm", "Rectangle", inherit=True)
c.addConstraint(("rarm", "l"), ("numBatteries","boatwidth", "boatdepth"), "((0.5 * x[1] - 0.5 * ( 9 * x[0])) ** 2 + (x[2] - 17) ** 2) ** 0.5")
c.addConstConstraint(("rarm", "w"), 60)
#
c.addConnection(("larm", "l"), ("holder", "topedge1"), angle=45)
c.addConnection(("rarm", "l"), ("holder", "botedge1"), angle=45)



c.toLibrary("BatteryStackMount")
