from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("servoMount", "MountedServo")

c.addSubcomponent("leftArm", "Rectangle")
c.addSubcomponent("rightArm", "Rectangle")

c.addParameter("supportLength", 60, parameterType="length") # = boat depth

c.addConstConstraint(("leftArm", "w"), 10)
c.addConstraint(("leftArm", "l"), "supportLength") #DEPTH OF BOAT - 3 for the tab

c.addConstConstraint(("rightArm", "w"), 10)
c.addConstraint(("rightArm", "l"), "supportLength") #DEPTH OF BOAT

c.join(("servoMount", "topedge1"), ("leftArm", "r")) #l/r, not t/b
c.join(("servoMount", "botedge1"), ("rightArm", "r"))
#
# c.inheritInterface("leftArmInterface", ("leftArm", "l"))
# c.inheritInterface("rightArmInterface", ("rightArm", "l"))
#
# c.addParameter("driveservo", "fs90r", paramType="dimension")
#
# c.inheritAllInterfaces("beam", prefix=None)
# c.inheritAllInterfaces("mount")
# c.addConnection(("beam", "face0"),
#                 ("mount", "decoration"),
#                 mode="hole", offset=Function(params="offset"))
#
# c.inheritAllInterfaces("beam")

c.toLibrary("ServoMountWithArms")
